﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Text.RegularExpressions;

namespace TestProject
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 프로그램 시작하기 - Main(argumentArray)

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        /// <param name="argumentArray">인자 배열</param>
        private static void Main(string[] argumentArray)
        {
            Console.Title = "Regex 클래스 : IsMatch 정적 메소드를 사용해 특정 파일 확장자를 갖는 파일 구하기";

            List<string> filePathList = GetFilePathList("d:\\TEMP", ".jpg|.png|.bmp|.JPG|.PNG|.BMP|.JPEG|.jpeg$");

            foreach(string filePath in filePathList)
            {
                Console.WriteLine(filePath);
            }
        }

        #endregion

        #region 파일 경로 리스트 구하기 - GetFilePathList(sourceDirectoryPath, fileExtensionPattern)

        /// <summary>
        /// 파일 경로 리스트 구하기
        /// </summary>
        /// <param name="sourceDirectoryPath">소스 디렉토리 경로</param>
        /// <param name="fileExtensionPattern">파일 확장자 패턴</param>
        /// <returns>파일 경로 리스트</returns>
        private static List<string> GetFilePathList(string sourceDirectoryPath, string fileExtensionPattern)
        {
            List<string> filePathList = new List<string>();

            foreach(string filePath in Directory.GetFiles(sourceDirectoryPath, "*.*", SearchOption.AllDirectories))
            {
                if(Regex.IsMatch(filePath, fileExtensionPattern))
                {
                    filePathList.Add(filePath);
                }
            }

            return filePathList;
        }

        #endregion
    }
}